// $Id: Plugin.java,v 1.5.4.3 2003/08/26 09:08:11 cssharp Exp $

/*									tab:2
 *
 *
 * "Copyright (c) 2000 and The Regents of the University 
 * of California.  All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without written
 * agreement is hereby granted, provided that the above copyright
 * notice and the following two paragraphs appear in all copies of
 * this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
 * DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 * DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 * CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Authors:	Dennis Chi, Nelson Lee
 * Date:        October 16 2002
 * Desc:        
 *
 */

/**
 * @author Dennis Chi
 * @author Nelson Lee
 */


package net.tinyos.sim;

import net.tinyos.sim.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;

/**
 * Event listener interface so that classes can implement and receive events through
 * handleEvent().
 */

public abstract class Plugin {
    protected TinyViz tv;
    protected SimEventBus eventBus;
    protected SimState state;
    protected CoordinateTransformer cT;
    protected MotePanel motePanel;
    protected JPanel pluginPanel;
    protected SimComm simComm;
    
    // MotePlugins MoteCoordinateAttributeChangedListener
    private AttributeChangedListener moteCoordinateAttributeChangedListener;
    
    private SimObjectAddRemoveListener moteSimObjectAddRemoveListener;

    public Plugin() {
    }
    
    public void initialize(TinyViz tv, JPanel pluginPanel) {
        this.tv = tv;
	this.eventBus = tv.getEventBus();
	this.state = tv.getSimState();
	this.cT = tv.getCoordTransformer();
	this.motePanel = tv.getMotePanel();
	this.pluginPanel = pluginPanel;
	this.simComm = tv.getSimComm();
    }
    
    public abstract void handleEvent(SimEvent event);

    public void register() {
      tv.setStatus(toString()+" registered");
    }

    public abstract void deregister();
    public void reset() { /* Do nothing */ }
    
    public abstract void draw(Graphics graphics);


}

