function moteIF = connect(port)
%CONNECT
%
%this function connects the current matlab environment to a serial port or
%socket.
%
%usage: connect('localhost:9000')
%       connect('COM1')
%       connect({'localhost:9000', 'c62b27d:10002', 'COM1', 'COM2'})

global COMM

if isempty(COMM)
    defineComm
end

if iscell(port)
    for i=1:length(port)
        moteIF{i}=connectToSerial(port{i});
    end
    return
end

if strncmpi(port, 'COM',3)
    if ~isempty(connectToSerial(port))
        moteIF=connectToSocket(['localhost:' num2str(9000+str2num(port(4:end)))]);
    end
elseif find(port==':')
    moteIF=connectToSocket(port);
else
	disp('usage: connect(''localhost:9000'')')
	disp('       connect(''COM1'')')
	disp('       connect({''localhost:9000'', ''c62b27d:10002'', ''COM1'', ''COM2''})')
end